/* see LICENSE file for copyright and license details. */
#ifndef COBBLE_CONNECTION_H
#define COBBLE_CONNECTION_H

#include <stdint.h>
#include <rxi/dyad.h>
#include <sys/socket.h>

#include <cobble/server.h>

enum protocol_state {
	HANDSHAKE = 0,
	STATUS = 1,
	LOGIN = 2,
	PLAY = 3
};

struct connection {
	dyad_Stream *dyad_stream;
	struct server *server;

	enum protocol_state protocol_state;
	int32_t protocol;
};

struct connection* connection_create();
void connection_destroy(struct connection*);
void connection_thread(void*);

#endif
