/* see LICENSE file for copyright and license details. */
#ifndef COBBLE_UTIL_H
#define COBBLE_UTIL_H

#define SAFE_MALLOC(n) smalloc(n, __LINE__)
#define SAFE_CALLOC(n) scalloc(n, __LINE__)
#define SAFE_REALLOC(ptr, n) srealloc((ptr), (n), __LINE__)

/* malloc that throws an error and exits if we run out of memory */
void* smalloc(size_t size, unsigned long line);
/* same as above but with calloc. block size is 1 */
void* scalloc(size_t size, unsigned long line);
/* same as above but with realloc */
void srealloc(void *ptr, size_t size, unsigned long line);

/* swap endian of a number */
void swap_endian(void*, size_t size);

#endif
