/* see LICENSE file for copyright and license details. */
#include <pthread.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <rxi/dyad.h>
#include <rxi/log.h>

#include <cobble/connection.h>
#include <cobble/nbt.h>
#include <cobble/server.h>
#include <cobble/util.h>

static void
tick(struct server *server)
{
	log_info("tick");
	/* for now the main thread does nothing */
}

static void
tick_thread(void *args)
{
	while (1) {
		tick((struct server*) args);
		usleep(1000 * 1000);
	}
}

int 
main(int argc, char** argv) 
{
	struct server *server;

	log_info("Starting server");
	// create and setup the server struct
	server = SAFE_MALLOC(sizeof(struct server));

	log_info("Starting network thread");
	dyad_init();
	server->dyad_stream = dyad_newStream();

	/* start the network thread */
	pthread_t conn_thread;
	pthread_create(&conn_thread, NULL, (void*) connection_thread, server);

	//pthread_t tick_thread;
	pthread_create(&conn_thread, NULL, (void*) tick_thread, server);

	while (1) {
		sleep(1);
	}	
}
